Attribute VB_Name = "basPreviewPrint"
Option Explicit

'all measurements used in PreviewPrint are in
'tenths of millimeters, this constant is provided
'for conversion of scales to millimeters if required
Public Const nMmToPP = 10#  'multiply value in mm by this for previewprint
Public Const nPPToMm = 0.1  'multiply value in previewprint by this for mm

'SetFont options
Public Const PPF_BOLD = 1
Public Const PPF_ITALIC = 2
Public Const PPF_UNDERLINE = 4
Public Const PPF_STRIKEOUT = 8

'SetTextAlign options
Public Const PPA_NOUPDATECP = 0
Public Const PPA_UPDATECP = 1

Public Const PPA_LEFT = 0
Public Const PPA_CENTER = 6
Public Const PPA_RIGHT = 2

Public Const PPA_TOP = 0
Public Const PPA_BASELINE = 24
Public Const PPA_BOTTOM = 8

'SetLineStyle styles
Public Const PPL_SOLID = 0
Public Const PPL_DASH = 1            ' -------
Public Const PPL_DOT = 2             ' .......
Public Const PPL_DASHDOT = 3         ' _._._._
Public Const PPL_DASHDOTDOT = 4      ' _.._.._
Public Const PPL_INSIDEFRAME = 6

'paper orientation
Public Const PPO_PORTRAIT = 1
Public Const PPO_LANDSCAPE = 2

'state constants
Public Const PPS_IDLE = 0
Public Const PPS_PREVIEW = 1
Public Const PPS_PRINT = 2

